#include "utils.h"
#include "sock.h"

int opensocket=-1;

/*
int readmessage(int fd, char* buffer, int bufsize){
  unsigned int msgsize=0;
  if(read(fd,&msgsize,sizeof(unsigned int))<sizeof(unsigned int)){
    say("erorr reading message length\n");
    return 1;
  }
  if(msgsize>bufsize){
    say("buffer too small: %d/%d\n",msgsize,bufsize);
    return 1;
  }
  do {
    int dif=read(fd,buffer,msgsize);
    if(dif<=0){
      say("error reading message\n");
      return 1;
    }
    msgsize-=dif;
    buffer+=dif;
  }while(msgsize);
  return 0;
}
*/

int readmessagepart(int fd, char** buffer, int bufsize, int* left_to_read){
  if((*left_to_read)==-1){//read the header
    if(read(fd,left_to_read,sizeof(int))<sizeof(int)){
      say("erorr reading message length\n");
      return 1;
    }
    if((*left_to_read)>bufsize){
      say("buffer too small: %d/%d\n",*left_to_read,bufsize);
      return 1;
    }
    return 0;
  }else{//read part of the message
    int dif=read(fd,*buffer,*left_to_read);
    if(dif==-1 && errno==EAGAIN){
      return 0;
    }
    if(dif<=0){
      say("error reading message\n");
      return 1;
    }
    (*left_to_read)-=dif;
    (*buffer)+=dif;
  }
  return 0;
}


static void writemessage(int fd, const char* message){
  if(!message){
    say("error writing null message\n");
    return;
  }
  unsigned int msgsize=strlen(message)+1;
  if(write(fd,&msgsize,sizeof(unsigned int))<sizeof(unsigned int)){
    say("error writing message length\n");
    return;
  }
  do {
    int dif=write(fd,message,msgsize);
    if(dif<=0){
      say("error writing message\n");
      return;
    }
    msgsize-=dif;
    message+=dif;
  }while(msgsize);
}

void sockreport(const char* format, ...){
  static char outbuffer[BUFSIZE];
  if(opensocket<0){
    fputs("< ",stderr);
    va_list ap;
    va_start(ap,format);
    vfprintf(stderr,format,ap);
    va_end(ap);
    fputc('\n',stderr);
    return;
  }
  va_list ap;
  va_start(ap, format);
  vsprintf(outbuffer, format, ap);
  va_end(ap);
  writemessage(opensocket,outbuffer);
}
